' === TempIntExtCalib.bas =====================================

' Read 08M2 internal temperature & DS18B20 external temperature
' and display both Celsius temperatures in the terminal window.

' We will use the difference between the readings
' to calibrate the readinternaltemp command.

' === Constants ======
  symbol DS18B20 = C.4        'DS18B20 data line on pin C.4

' === Variables ====
  symbol  tempI = w0          'internal Celsius temperature
  symbol  tempE = w1          'external Celsius temperature
    
' === Directives ===
  #com 6                      'specify serial port
  #picaxe 08M2                'specify processor
  #terminal 4800              'open the terminal window
  #no_data                    'save time downloading
	
' === Begin Main Program ======================================
do
  readinternaltemp IT_5V0, 0, tempI        'read internal temp
  sertxd ("Int. = ", #tempI , " C; ")      'send it to terminal
  
  readtemp DS18B20, tempE                  'read external temp
  sertxd ("Ext. = ", #tempE, " C; ",CR,LF) 'send it to terminal

  wait 5                                   'slow it down a bit
loop