' === TempIntExtCold.bas =============================================

' Read 08M2 internal temperature & DS18B20 external temperature,
' and display both Celsius temperatures in the terminal window.

' Porgram demonstrates loss of calibration as temperature changes.

' === Constants ======
  symbol DS18B20 = C.4            'DS18B20 data line on pin C.4
  symbol      HT = 9              'ASCII code for horizontal tab   [1]
  
' === Variables ====
  symbol  tempI = w0              'stores Internal temperature
  symbol  tempE = w1              'stores External temperature
  symbol minute = b4              'minute counter
  
' === Directives ===
  #com 6                          'specify serial port
  #picaxe 08M2                    'specify processor
  #terminal 4800                  'open the terminal window
  #no_data                        'save time downloading
	
' === Begin Main Program =============================================

' First, send column headings to the terminal window               [2]
  sertxd ("Minute", HT, "tempI", HT, "tempE", CR, LF)

for minute = 0 to 60                         'loop once a minute   [3]
  time = 0                                   'initialize seconds   [4]
  
  readinternaltemp IT_5V0, -257, tempI       'read internal temp
  readtemp DS18B20, tempE                    'read external temp
  sertxd (#minute,HT,#tempI,HT,#tempE,CR,LF) 'send data to terminal
  
  do                                         'wait a minute        [5]
  loop until time = 60
next minute