' === TempRangeTest.bas ================================================

' This program tests the conversion algorithm by displaying equivalent
' C & F temps in the terminal window for the full range of the DS18B20.
 
' === Variables ===
  symbol tempC = w0             'stores Celsius temperature
  symbol tempF = w1             'stores Fahrenheit temperature
  symbol signC = b4             'used to display + or - sign for C   [1]
  symbol signF = b5             'used to display + or - sign for F
  symbol index = b6             'used in for/next loops
  
' === Directives ===
  #com 6                        'specify serial port
  #picaxe 08M2                  'specify processor
  #terminal 4800                'open the terminal window
  #no_data                      'save time downloading

' === Begin Main Program ===============================================

  for index = 125 to 0 step -1  '+125C down to 0C)                   [2]
    tempC = index               'see text                            [3]
    gosub ConvertC2F            'convert Celsius to Fahrenheit
    gosub DisplayTemps          'send both temps to terminal window
  next index
   
  for index = 129 to 183        '-1C down to -55C)                   [4]
    tempC = index               'see text                            [5]
    gosub ConvertC2F            'convert Celsius to Fahrenheit
    gosub DisplayTemps          'send both temps to terminal window
  next index
  
  end                           'avoids falling into subroutines     [6]

' === End Main Program: Subroutines Follow =============================
 
' === Subroutine ConvertC2F: Convert Celsius to Fahrenheit ===
 
ConvertC2F:
  select case tempC
    case 0 to 125               'C=+125 downto 0 (F=+257 downto +32) [7]
      if tempC = 0 then
        signC = " "
      else
        signC = "+"
      endif
      signF = "+"
      tempF = tempC *9 / 5 + 32
    case 129 to 146             'C=-1 downto -18 (F=+31 downto 0)    [8]
      signC = "-"
      tempC = tempC - 128
      tempF = tempC *9 / 5
      tempF = 32 - tempF                                             [9]
      if tempF = 0 then
        signF = " "
      else
        signF = "+"
      endif        
    case 147 to 183             'C=-19 downto -55 (F=-2 downto -67) [10]
      signC = "-"
      signF = "-"
      tempC = tempC - 128                                           [11]
      tempF = tempC *9 / 5 - 32          
  endselect
  
  return

' === Subroutine displayTemps: Display both temps in terminal window ===

DisplayTemps:
  sertxd (signC,#tempC,"C = ")         'display tempC in terminal window
  sertxd (signF,#tempF,"F",CR,LF)      'display tempF in terminal window
  
  return